Package ru.bitel.bgbilling.server.util

# Class DefaultServerSetup

java.lang.Object
ru.bitel.bgbilling.kernel.base.server.logger.BGLogger
ru.bitel.common.ParameterMap
ru.bitel.common.Preferences
ru.bitel.bgbilling.server.util.DefaultServerSetup

Direct Known Subclasses:
  `Setup`

public class DefaultServerSetup extends Preferences
То же что и Preferences, только умеет работать с пулом соединений к базе.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `class`
  `DefaultServerSetup.DatabaseData`

  ## Nested classes/interfaces inherited from class ru.bitel.common.ParameterMap

  `ParameterMap.DefaultParameterMap`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected DefaultServerSetup.DatabaseData`
  `databaseData`
  `static final int`
  `RETURN_FAKE`
  `static final int`
  `RETURN_MASTER`
  `static final int`
  `RETURN_NULL`
  `static final int`
  `RETURN_SLAVE`

  ### Fields inherited from class ru.bitel.common.Preferences

  `bundleName, data`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultServerSetup()`
  `DefaultServerSetup(String bundleName)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `DefaultServerSetup.DatabaseData`
  `getDatabaseData()`
  `Connection`
  `getDBConnection()`
  Возвращает отдельное соединение с Master базой.
  `Connection`
  `getDBConnection(boolean autoCommit)`
  `final Connection`
  `getDBConnectionFromPool()`
  Возвращает соединение с Master БД из пула.
  `final Connection`
  `getDBConnectionFromPool(boolean autoCommit)`
  Возвращает соединение с Master БД из пула.
  `final Connection`
  `getDBSlaveConnectionFromPool()`
  Возвращает соединение с Slave БД из пула.
  `final Connection`
  `getDBSlaveConnectionFromPool(Connection master)`
  Возвращает соединение с Slave БД из пула.
  `final Connection`
  `getDBTrashConnectionFromPool(String tableName, int retType)`
  Возвращает соединение с мусорной БД если она описана для таблицы в конфиге либо в зависимости от retType.
  `final Connection`
  `getDBTrashOrMasterConnectionFromPool(String tableName)`
  Возвращение соединения к выделенной "мусорной" либо Master-базе (если треш-база не найдена).
  `final Connection`
  `getDBTrashOrSlaveConnectionFromPool(String tableName)`
  Возвращение соединения к выделенной "мусорной" либо Slave-базе
  `static Context`
  `getEnvironment()`
  `float`
  `getMasterPoolLoad()`
  Возвращает отношение числа активных соединений к максимально разрешённому числу соединений Мастер - БД.
  `String`
  `getPoolStackTrace()`
  `String`
  `getPoolStatus()`
  Отчет по статусу пулов соединений
  `ScheduledExecutorService`
  `getScheduledExecutorService()`
  `final Set<String>`
  `getSlaveBaseId()`
  Возвращает идентификаторы slave баз.
  `final Connection`
  `getSlaveConnectionFromPool(String poolId)`
  Возвращает соединение с slave базой.
  `final Set<String>`
  `getTrashBaseId()`
  Возвращает идентификаторы trash баз.
  `final Connection`
  `getTrashConnectionFromPool(String poolId)`
  Возвращает соединение с trash базой.
  `boolean`
  `initConnectionPool()`
  Инициализация пулов соединений с мастер и slave базами.
  `void`
  `initJNDI()`
  `Object`
  `initMQ()`
  `protected void`
  `initTrashPools()`
  Инициализация пулов соединений к "мусорным" базам.
  `boolean`
  `isReplicationAvailable(String slaveId)`
  Проверяет доступность Slave базы
  `boolean`
  `isReplicationEnabled(String slaveId)`
  Deprecated.
  `boolean`
  `isReplicationNotBehindMaster(String slaveId)`
  Проверяет есть ли отставание Slave базы
  `void`
  `logConfigure(String log)`
  `final void`
  `returnConToPool(Connection con)`
  Deprecated.
  `void`
  `setReplicationAvailable(String slaveId, boolean available)`
  Установка/Отключение доступности Slave базы
  `void`
  `setReplicationEnabled(String slaveId, boolean enable)`
  Deprecated.
  `void`
  `setReplicationNotBehindMaster(String slaveId, boolean isNotBehind)`
  Включение/Отключение флага отставания Slave базы

  ### Methods inherited from class ru.bitel.common.Preferences

  `entrySet, extract, get, getMap, getObject, getObject, loadBundle, loadData, loadData, loadDataEntry, loadFromInputStream, loadModuleSetup, putObject, removeObject, set, updateData`

  ### Methods inherited from class ru.bitel.common.ParameterMap

  `addActionListener, filter, get, getBigDecimal, getBoolean, getChar, getDouble, getEnum, getFloat, getInt, getIntegerList, getLocalDate, getLong, inherit, sub, subIndexed, subKeyed, subLined, throwActionEvent, toReference, toString`

  ### Methods inherited from class ru.bitel.bgbilling.kernel.base.server.logger.BGLogger

  `error, error, error, getLogger, logError, logError, warn`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### databaseData

    protected DefaultServerSetup.DatabaseData databaseData

  - ### RETURN_NULL

    public static final int RETURN_NULL
    See Also:
      - Constant Field Values

  - ### RETURN_FAKE

    public static final int RETURN_FAKE
    See Also:
      - Constant Field Values

  - ### RETURN_SLAVE

    public static final int RETURN_SLAVE
    See Also:
      - Constant Field Values

  - ### RETURN_MASTER

    public static final int RETURN_MASTER
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### DefaultServerSetup

    public DefaultServerSetup(String bundleName)

  - ### DefaultServerSetup

    public DefaultServerSetup()

- ## Method Details

  - ### isReplicationEnabled

    @Deprecated public boolean isReplicationEnabled(String slaveId)
    Deprecated.
    Использовать `isReplicationNotBehindMaster(String)`
    Parameters:
      `slaveId` -
    Returns:

  - ### setReplicationEnabled

    @Deprecated public void setReplicationEnabled(String slaveId, boolean enable)
    Deprecated.
    Использовать `setReplicationNotBehindMaster(String, boolean)`
    Parameters:
      `slaveId` -
      `enable` -

  - ### setReplicationNotBehindMaster

    public void setReplicationNotBehindMaster(String slaveId, boolean isNotBehind)
    Включение/Отключение флага отставания Slave базы
    Parameters:
      `slaveId` - идентификатор Slave базы
      `isNotBehind` - true - отставание выключено, false - отставание включено

  - ### isReplicationNotBehindMaster

    public boolean isReplicationNotBehindMaster(String slaveId)
    Проверяет есть ли отставание Slave базы
    Parameters:
      `slaveId` - идентификатор Slave базы
    Returns:

  - ### isReplicationAvailable

    public boolean isReplicationAvailable(String slaveId)
    Проверяет доступность Slave базы
    Parameters:
      `slaveId` - идентификатор Slave базы
    Returns:
      true - если доступна, false - если не доступна

  - ### setReplicationAvailable

    public void setReplicationAvailable(String slaveId, boolean available)
    Установка/Отключение доступности Slave базы
    Parameters:
      `slaveId` - идентификатор Slave базы
      `available` - true -не доступно; false - доступно

  - ### getScheduledExecutorService

    public ScheduledExecutorService getScheduledExecutorService()

  - ### initConnectionPool

    public boolean initConnectionPool()
    Инициализация пулов соединений с мастер и slave базами.

  - ### initTrashPools

    protected void initTrashPools()
    Инициализация пулов соединений к "мусорным" базам.

  - ### initJNDI

    public void initJNDI()

  - ### getEnvironment

    public static Context getEnvironment() throws NamingException
    Throws:
      `NamingException`

  - ### initMQ

    public Object initMQ()

  - ### getDBConnectionFromPool

    public final Connection getDBConnectionFromPool()
    Возвращает соединение с Master БД из пула.
    Returns:
      соединение с Master БД либо null в случае недоступности.

  - ### getDBConnectionFromPool

    public final Connection getDBConnectionFromPool(boolean autoCommit)
    Возвращает соединение с Master БД из пула.
    Returns:
      соединение с Master БД либо null в случае недоступности.

  - ### getDBSlaveConnectionFromPool

    public final Connection getDBSlaveConnectionFromPool()
    Возвращает соединение с Slave БД из пула. Если Slave БД не определены в конфигурации - возвращает из Master пула.
    Returns:

  - ### getDBSlaveConnectionFromPool

    public final Connection getDBSlaveConnectionFromPool(Connection master)
    Возвращает соединение с Slave БД из пула. Если Slave БД не определены в конфигурации - возвращает из Master пула.
    Parameters:
      `master` - masterConnection
    Returns:

  - ### getDBTrashConnectionFromPool

    public final Connection getDBTrashConnectionFromPool(String tableName, int retType)
    Возвращает соединение с мусорной БД если она описана для таблицы в конфиге либо в зависимости от retType.
    Parameters:
      `tableName` - имя таблицы.
      `retType` - `RETURN_FAKE`, `RETURN_SLAVE` либо `RETURN_MASTER`.
    Returns:
      если не указана конфигурация мусорной БД может быть возвращен коннект к мастер БД, фейковый коннект либо коннект Slave БД.

  - ### getDBTrashOrMasterConnectionFromPool

    public final Connection getDBTrashOrMasterConnectionFromPool(String tableName)
    Возвращение соединения к выделенной "мусорной" либо Master-базе (если треш-база не найдена).
    Parameters:
      `tableName` -
    Returns:

  - ### getDBTrashOrSlaveConnectionFromPool

    public final Connection getDBTrashOrSlaveConnectionFromPool(String tableName)
    Возвращение соединения к выделенной "мусорной" либо Slave-базе
    Parameters:
      `tableName` -
    Returns:

  - ### getSlaveConnectionFromPool

    public final Connection getSlaveConnectionFromPool(String poolId)
    Возвращает соединение с slave базой. если неверная база то null со всем вытекающим, так как применяется только при принудительном выборе базы в некоторых специфичных служебных случаях.
    Parameters:
      `poolId` - - ид базы
    Returns:
      коннекшен

  - ### getSlaveBaseId

    public final Set<String> getSlaveBaseId()
    Возвращает идентификаторы slave баз.
    Returns:

  - ### getTrashBaseId

    public final Set<String> getTrashBaseId()
    Возвращает идентификаторы trash баз.
    Returns:

  - ### getTrashConnectionFromPool

    public final Connection getTrashConnectionFromPool(String poolId)
    Возвращает соединение с trash базой. если неверная база то null со всем вытекающим, так как применяется только при принудительном выборе базы в некоторых специфичных служебных случаях.
    Parameters:
      `poolId` - - ид базы
    Returns:
      коннекшен

  - ### returnConToPool

    @Deprecated public final void returnConToPool(Connection con)
    Deprecated.
    Возвращает соединение с БД в пул.
    Parameters:
      `con` -
    See Also:
      - invalid reference

            Utils#closeConnection(Connection)

  - ### getPoolStatus

    public String getPoolStatus()
    Отчет по статусу пулов соединений
    Returns:

  - ### getMasterPoolLoad

    public float getMasterPoolLoad()
    Возвращает отношение числа активных соединений к максимально разрешённому числу соединений Мастер - БД.
    Returns:

  - ### getPoolStackTrace

    public String getPoolStackTrace()

  - ### getDBConnection

    public Connection getDBConnection(boolean autoCommit)

  - ### getDBConnection

    public Connection getDBConnection()
    Возвращает отдельное соединение с Master базой.
    Returns:

  - ### logConfigure

    public void logConfigure(String log)

  - ### getDatabaseData

    public DefaultServerSetup.DatabaseData getDatabaseData()